application:setBackgroundColor(0x000000)

--TNT particle engine: set particles

local function getParticles()
-- load graphics
local waveGFX = (Texture.new("shockwave1.png"))	
local sparklesGFX = (Texture.new("exp1.png"))	
local smokeGFX = (Texture.new("smoke.png"))	

---------------------------------------------------------------------
	-- define explosion weave
	local wave = CParticles.new(waveGFX, 1, 1, 0, "add")
	wave:setSize(0.1)
	wave:setAlpha(190)
	wave:setColor(150,120,130)
	wave:setAlphaMorphOut(0, 1)
	wave:setSizeMorphOut(2, 1)

	---------------------------------------------------------------------
	-- define explosion sparkles
	local sparkles = CParticles.new(sparklesGFX, 20, 1, 0, "add")
	sparkles:setSize(0.2, 0.2)
	sparkles:setSpeed(150, 350)
	sparkles:setAlpha(0)
	sparkles:setDirection(0, 360)
	sparkles:setColor(255,100,190)
	sparkles:setAlphaMorphIn(255, .5)
	sparkles:setAlphaMorphOut(0, .5)

	---------------------------------------------------------------------
	-- define explosion sparkles
	local smoke = CParticles.new(smokeGFX, 5, 1, 0, "add")
	smoke:setSize(1, 2)
	smoke:setSpeed(100, 160)
	smoke:setRotation(0, 80, 360, -80)
	smoke:setDirection(0, 360)
	smoke:setColor(120,90,150)
	smoke:setAlphaMorphOut(0, 1)
	smoke:setSizeMorphOut(3, 1)
	
		wave:setLoopMode(1)
		sparkles:setLoopMode(1)
		smoke:setLoopMode(1)
	
	return wave, sparkles, smoke
end

--auto explode button
local buttonSprite = Bitmap.new(Texture.new("blue-button.png"))
buttonSprite:setAnchorPoint(.5,.5)
local explodingbutton = Button.new(buttonSprite,buttonSprite)
explodingbutton:setPosition(250,100)
stage:addChild(explodingbutton)

--make gift explode button
local buttonSprite2 = Bitmap.new(Texture.new("blue-button.png"))
local explodingbutton2 = Button.new(buttonSprite2,buttonSprite2)
explodingbutton2:setPosition(200,300)
stage:addChild(explodingbutton2)

--gift
local gift = Bitmap.new(Texture.new("gift.png", true, {transparentColor = "0xffffff"}))
gift:setAnchorPoint(.5,.5)
gift:setScale(.2)
gift:setPosition(250, 450)
stage:addChild(gift)

		---------------------------------------------------------------------
		-- set emitter over button explodingbutton
		
		local px, py = explodingbutton:getPosition()
		emitter_1 = CEmitter.new(px,py,0, stage)
		---------------------------------------------------------------------
		-- assign particle to emitter 1

		local wv, sp, sm = getParticles()

		emitter_1:assignParticles(wv)
		emitter_1:assignParticles(sp)
		emitter_1:assignParticles(sm)



local function destroyButton()
print("destroy button")
		emitter_1:start() --start effect
		
		--remove button
		explodingbutton:removeFromParent()
		explodingbutton = nil
		
		--remove emitter when finished
		emitter_1:addEventListener("EMITTER_FINISHED", function()
				emitter_1:free()

				
		end)
end


		---------------------------------------------------------------------
		-- set emitter over gift
		local px2, py2 = gift:getPosition()
		emitter_2 = CEmitter.new(px2,py2,0, stage)
		---------------------------------------------------------------------
		-- assign particle to emitters

		local wv2, sp2, sm2 = getParticles()

		emitter_2:assignParticles(wv2)
		emitter_2:assignParticles(sp2)
		emitter_2:assignParticles(sm2)


local function destroyGift()
print("destroy gift")
		emitter_2:start() --start effect
		
		--remove button
		gift:removeFromParent()
		gift = nil
		
		--remove emitter
		emitter_2:addEventListener("EMITTER_FINISHED", function()
				emitter_2:free()

				
		end)
end

explodingbutton:addEventListener("click", destroyButton)
explodingbutton2:addEventListener("click", destroyGift)